#include <iostream>

using namespace std;


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin>>t;
    for(int k=0; k<t; k++)
    {


    int n;
    cin>>n;
    long long int a[n];
    int pamti1=0, pamti2=0;
    bool kecevi=true;
    for(int i=0; i<n; i++)
    {
        cin>>a[i];
        if(a[i]!=0) pamti1=i;
        if(a[i]!=1 && a[i]!=-1) kecevi=false;
    }
    long long int b[n];
    for(int i=0; i<n; i++)
    {
        cin>>b[i];
        if(b[i]!=0) pamti2=i;
        if(b[i]!=1 && b[i]!=-1) kecevi=false;
    }
    if(kecevi)
    {
        bool ispunjava=true;
        for(int i=0; i<n-1; i++)
        {
            if(a[i]!=b[i])
            {
                if(a[i+1]==a[i])
                {
                    ispunjava=false;
                    break;
                }
                else
                {
                    a[i]=-a[i];
                    a[i+1]=-a[i+1];
                }
            }
        }
        if(a[n-1]!=b[n-1]) ispunjava=false;
        if(ispunjava) cout<<"DA"<<"\n";
        else cout<<"NE"<<"\n";
    }
    else
    {
    if(abs(a[pamti1])==abs(b[pamti2]))
    {

    if(a[pamti1]/b[pamti2]<0)
    {
        if((pamti2-pamti1)%2==0)
        {
            cout<<"NE"<<"\n";
            continue;
        }
        else
        {
            cout<<"DA"<<"\n";
            continue;
        }
    }
    else
    {
        if((pamti2-pamti1)%2==0)
        {
            cout<<"DA"<<"\n";
            continue;
        }
        else
        {
            cout<<"NE"<<"\n";
            continue;
        }
    }
    }
    else
    {
        cout<<"NE"<<"\n";
        continue;
    }

    }
    }

}